import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Attack here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FastMessage  extends UIControls
{
    /**
     * Act - do whatever the Attack wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private String displayMessage;
    private int opacity = 255, startY;
    private long startTime;
    
    public FastMessage(String msg){
        displayMessage = msg;
    }
    public void addedToWorld(World world){
        startY = getY();
        setLocation(100+getX(), 100+getY());
        getImage().scale(200, 200);
        update();
        startTime = System.currentTimeMillis();
    }
    public void update(){
        getImage().clear();
        getImage().setTransparency(opacity);
        getImage().setColor(new Color(255, 0 , 0));
        getImage().drawString(displayMessage, 0, 100);
    }
    public void end(){
        getWorld().removeObject(this);
    }
    public void act() 
    {
        // Add your action code here.
        if(getWorld()!=null){
            long nowTime = System.currentTimeMillis();
            opacity = (int)(opacity-((nowTime-startTime)/6));
            getImage().setTransparency(opacity);
            if(opacity<=10){
                end();
                return;
            }
            if(getY()>startY)
                setLocation(getX(), (int)(getY()-((nowTime-startTime)/1.5)));
            startTime = nowTime;
        }
    }    
}
