import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.lang.*;
import java.lang.Math;
import java.util.Random;
/**
 * Write a description of class Main here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
/*TODO:
 *
 * 
 * Implement Shops to help player grow.
 * Implement Monsters to help level the player
 * Implement a Level Information inside the Hero Class to help with the game information.
 * 
 * 
 */
public class Main  extends World
{
    //Game Screen Variables
    private final static String attentions[] = new String[]{
      new String("You died! Try not to this time! You have the gift!"),
      new String("My name is ~~~~ I have brought you here to help. Please come to the village just follow the path you are on and you will find us!"),
      new String("Great you made it! I knew you had it in you, anyways I need you to now level up to lvl2 then come back to the village Goodluck! *Remember come back your health will be restored!"),
      new String("Amazing you were very fast! Come meet"),
    };
    private final int MapCols = 20; //X
    private final int MapRows = 13; //Y
    private final int CenterPosition[] = new int[]{10,7};  // X Y
    private final int PlayerHeight = 32;
    private final int PlayerWidth = 32;
    private final int Speed = 32;
    private Hero Player;
    private Monster Enemy;
    private boolean inBattle = false, inAttention=true, inQuest=true;
    private BattleScreen Fight;
    private Textbox PPos;
    private Random randNumber;
    private int Quest = 1;
    //private Tiles GameMap[][];
    private Map GameMap;
    private int PlayerLevel = 1;
    private int PlayerPosition[] = new int[]{0,0};
    private int PlayerSpeed = 32;
    private int PlayerDelay = 8;
    private int PlayerLeftMoves = 1, PlayerRightMoves = 1, PlayerUpMoves = 1, PlayerDownMoves = 1;
    private final int MonsterAreas[] = new int[] {14};
    private final int MonsterProbability[] = new int[]{0, 30, 5}; //Min -- Max -- Number for action to occur
    private final int Map1StartX = 0;
    private final int Map1StartY = 0;
    
    /**
     * Constructor for objects of class Main.
     * 
     */
    public Main()
    {    
        super(640, 416, 1);
        randNumber = new Random();
        /*Map Declarations*/
        Fight = new BattleScreen();
        Enemy = new Monster();
        GameMap = new Map(MapCols, MapRows);
        GameMap.setMap(new Map1().getMap(), Map1StartX, Map1StartY);
    }
    public void started(){
        Setup();
    }
    public void stopped(){
        
    }
    public void act(){
            if(!inAttention){
                if(!inBattle){
                    //Player Movement
                    if(Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("w")){
                        double upY = Math.floor((Player.getY()-PlayerHeight)/GameMap.tileH());
                        double leftX = Math.floor((Player.getX()-PlayerWidth)/GameMap.tileW());
                        double rightX = Math.floor((Player.getX()+PlayerWidth)/GameMap.tileW());
                    
                        boolean upLeft = false;
                        boolean upRight = false;
                        if(upY>0 && leftX>0 && rightX<(GameMap.cols()-1)){
                            upLeft = GameMap.tileAt((int)leftX, (int)upY).isWalkable();
                            upRight = GameMap.tileAt((int)rightX, (int)upY).isWalkable();
                        }
                        if((upLeft && upRight) && GameMap.currentY()>=0 && PlayerPosition[1]>0) {
                            if(PlayerPosition[1]==(GameMap.currentY()+CenterPosition[1]) && GameMap.currentY() != 0){
                                PlayerPosition[1] -= 1;
                                GameMap.drawMap(GameMap.currentX(), GameMap.currentY()-1);
                            }else{
                                PlayerPosition[1] -= 1;
                                Player.setLocation(Player.getX(), Player.getY()-PlayerSpeed);
                            }
                        }
                        attackProbability();
                    }else
                    if(Greenfoot.isKeyDown("down") || Greenfoot.isKeyDown("s")){
                        double downY = Math.floor(((Player.getY())+PlayerHeight)/GameMap.tileH());
                        double leftX = Math.floor(((Player.getX())-PlayerWidth)/GameMap.tileW());
                        double rightX = Math.floor(((Player.getX())+PlayerWidth)/GameMap.tileW());
                    
                        boolean downLeft = false;
                        boolean downRight = false;
                        if(downY<(GameMap.rows()-1) && leftX>0 && rightX<(GameMap.cols()-1)){    
                            downLeft = GameMap.tileAt((int)leftX, (int)downY).isWalkable();
                            downRight = GameMap.tileAt((int)rightX, (int)downY).isWalkable();
                        }
                        if((downLeft && downRight) && GameMap.currentY()<=(GameMap.rows()-GameMap.tileR()) && (PlayerPosition[1])<(GameMap.rows()-1)){
                            if(PlayerPosition[1]==(GameMap.currentY()+CenterPosition[1]) && GameMap.currentY() != (GameMap.rows()-GameMap.tileR())){
                                PlayerPosition[1] += 1;
                                GameMap.drawMap(GameMap.currentX(), GameMap.currentY()+1);
                            }else{
                                PlayerPosition[1] += 1;
                                Player.setLocation(Player.getX(), Player.getY()+PlayerSpeed);
                            }
                        }
                        attackProbability();
                    }else
                    if(Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d")){
                        double downY = Math.floor(((Player.getY())+PlayerHeight)/GameMap.tileH());
                        double upY = Math.floor(((Player.getY())-PlayerHeight)/GameMap.tileH());
                        double rightX = Math.floor(((Player.getX())+PlayerWidth)/GameMap.tileW());
                    
                        boolean upRight = false;
                        boolean downRight = false;
                        Player.right();
                        if(downY<(GameMap.rows()-1) && upY>0 && rightX<(GameMap.cols()-1)){
                            upRight = GameMap.tileAt((int)rightX, (int)upY).isWalkable();
                            downRight = GameMap.tileAt((int)rightX, (int)downY).isWalkable();
                        }
                        if((upRight || downRight) && GameMap.currentX()<=(GameMap.cols()-GameMap.tileC()) && PlayerPosition[0]<(GameMap.cols()-1)){
                            if(PlayerPosition[0]==(GameMap.currentX()+CenterPosition[0]) && GameMap.currentX() != (GameMap.cols()-GameMap.tileC())){
                                PlayerPosition[0] += 1;
                                GameMap.drawMap(GameMap.currentX()+1, GameMap.currentY());
                            }else{
                                PlayerPosition[0] += 1;
                                Player.setLocation(Player.getX()+PlayerSpeed, Player.getY());
                            }
                        }
                        attackProbability();
                    }else
                    if(Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a")){
                        double downY = Math.floor(((Player.getY())+PlayerHeight)/GameMap.tileH());
                        double upY = Math.floor(((Player.getY())-PlayerHeight)/GameMap.tileH());
                        double leftX = Math.floor(((Player.getX())-PlayerWidth)/GameMap.tileW());
                
                        boolean upLeft = false;
                        boolean downLeft = false;
                        Player.left();
                        if(downY<(GameMap.rows()-1) && upY>0 && leftX>0){
                            upLeft = GameMap.tileAt((int)leftX, (int)upY).isWalkable();
                            downLeft = GameMap.tileAt((int)leftX, (int)downY).isWalkable();
                        }
                        if((downLeft || upLeft) && GameMap.currentX()>=0 && (PlayerPosition[0])>0){
                            if(PlayerPosition[0]==(GameMap.currentX()+CenterPosition[0]) && GameMap.currentX() != 0){
                                PlayerPosition[0] -= 1;
                                GameMap.drawMap(GameMap.currentX()-1, GameMap.currentY());
                            }else{
                                
                                PlayerPosition[0] -= 1;
                                Player.setLocation(Player.getX()-PlayerSpeed, Player.getY());
                            }
                        }
                        attackProbability();
                    }
                }else{
                    if(!Fight.isFighting()){
                        Fight.removeFromWorld();
                        removeObject(Fight);
                        if(!Player.isAlive()){
                            addObject(new Attention(attentions[0]),100,50);
                            GameMap.drawMap(Map1StartX, Map1StartY);
                            Player.resetStatus();
                            Player.setLocation(16+CenterPosition[0]*32, 16+CenterPosition[1]*32);
                            PlayerPosition[0] = CenterPosition[0]+GameMap.currentX();
                            PlayerPosition[1] = CenterPosition[1]+GameMap.currentY();
                        }
                        Player.checkLevel();
                        int Stats[] = Player.getStats();
                        PPos.caption("Level: " + Stats[0] + " XP: "+ Stats[4]);
                        inBattle = false;
                    }
                }
            }else
            if(Greenfoot.isKeyDown("space")){
                inAttention = false;
            }
    }
    public void Setup(){
        GameScreen();
    }
    public void attackProbability(){
        boolean inArea = false;
        for(int i=0; i<MonsterAreas.length; i++){
                    if(GameMap.currentMap()[PlayerPosition[1]][PlayerPosition[0]] == MonsterAreas[i]){
                        if((randNumber.nextInt(MonsterProbability[1]-MonsterProbability[0]+1)+MonsterProbability[0]) == MonsterProbability[2]){
                            inBattle = true;
                            switch(randNumber.nextInt(3)+1){
                                case 1:
                                    Enemy = new WildRabbit(Player.getStats()[0]);    
                                break;
                                case 2:
                                    Enemy = new MindFighter(Player.getStats()[0]);
                                break;
                                default:
                                    Enemy = new GreenMan(Player.getStats()[0]);
                            }
                            Fight.setupBattle(Player, Enemy);
                            addObject(Fight, 0, 0);
                        }
                        inArea = true;
                        int Stats[] = Player.getStats();
                        PPos.caption("Level: " + Stats[0] + " XP: "+ Stats[4]);
                    }
        }
        if(!inArea){
            Player.resetStatus();
            int Stats[] = Player.getStats();
            if(inQuest){
                switch(Quest){
                        case 1:
                            if(GameMap.currentMap()[PlayerPosition[1]][PlayerPosition[0]] == 21){
                                addObject(new Attention(attentions[2]),100,50);
                                inAttention = true;
                                Quest += 1;
                            }
                        break;
                        case 2:
                        if(GameMap.currentMap()[PlayerPosition[1]][PlayerPosition[0]] == 21){
                            System.out.println("Level: "+Player.getStats()[0]);
                            if(Player.getStats()[0]>=2){
                                addObject(new Attention(attentions[3]),100,50);
                                inAttention = true;
                                Quest += 1;
                                //Til I add more 
                                //inQuest = false; //Switch this one so nothing else occurs.
                            }else{
                                PPos.caption("Quest Pending!");
                                addObject(new FastAttention(attentions[2]),100,50);
                            }
                        }
                        break;
                        case 3:
                            PPos.caption("Quest Pending!");
                        break;
                        default:
                        
                    }
            }else{
                PPos.caption("City");
            }
        }
    }
    public void drawHero(){
        Player = new Hero();
        addObject(Player, 16+CenterPosition[0]*32, 16+CenterPosition[1]*32);
        PlayerPosition[0] = CenterPosition[0]+GameMap.currentX();
        PlayerPosition[1] = CenterPosition[1]+GameMap.currentY();
        int Stats[] = Player.getStats();
        PPos = new Textbox("Level: " + Stats[0] + " XP: " + Stats[4]);
        addObject(PPos, 150, 380);
    }
    public void GameScreen(){
        addObject(GameMap,0,0);
        drawHero();
        addObject(new Attention(attentions[1]),100,50);
    }
    public void rmGameScreen(){
        removeObject(GameMap);  
        removeObject(Player);
    }
    public Button addButton(String Caption, int x, int y){
        Button BN = new Button(Caption, x, y);
        addObject(BN,x, y);
        return BN;
    }
}
