import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Map here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Map  extends Actor
{
    
    private final int TileWidth = 32;
    private final int TileHeight = 32;
    private final int TileWalk[] = new int[] {1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0};
    private static GreenfootImage TileImages[] = new GreenfootImage[]{
                    new GreenfootImage("ol00.gif"),
                    new GreenfootImage("tile01.JPG"), new GreenfootImage("tile02.JPG"),
                    new GreenfootImage("tile03.JPG"), new GreenfootImage("tile04.JPG"),
                    new GreenfootImage("tile05.JPG"), new GreenfootImage("tile06.JPG"),
                    new GreenfootImage("tile07.JPG"), new GreenfootImage("tile08.JPG"),
                    new GreenfootImage("tile09.JPG"), new GreenfootImage("tile10.JPG"),
                    new GreenfootImage("tile11.JPG"), new GreenfootImage("tile12.JPG"),
                    new GreenfootImage("tile13.JPG"), new GreenfootImage("tile14.JPG"),
                    new GreenfootImage("tile15.JPG"), new GreenfootImage("tile16.JPG"),
                    new GreenfootImage("tile17.JPG"), new GreenfootImage("tile18.JPG"),
                    new GreenfootImage("tile19.JPG"), new GreenfootImage("tile20.JPG"),
                    new GreenfootImage("tile21.JPG"), new GreenfootImage("tile22.JPG"),
                    new GreenfootImage("tile23.JPG"), new GreenfootImage("tile24.JPG"),
                    new GreenfootImage("tile25.JPG"), new GreenfootImage("tile26.JPG"),
                    new GreenfootImage("tile27.JPG"), new GreenfootImage("tile28.JPG"),
                    new GreenfootImage("tile29.JPG"), new GreenfootImage("tile30.JPG"),
                    new GreenfootImage("tile31.JPG"), new GreenfootImage("tile32.JPG"),
                    new GreenfootImage("tile33.JPG")
    };
    private Tiles RMap[][];
    private int TileRows;
    private int TileCols;
    private int CurrentMap[][];
    private int CurrentMapX;
    private int CurrentMapY;
    public Map(int TC, int TR){
        TileRows = TR;
        TileCols = TC;
        RMap = new Tiles[TR][TC];
    }
    public void setMap(int m[][], int startX, int startY){
            CurrentMap = m;
            CurrentMapX = startX;
            CurrentMapY = startY;
    }
    
    public void addedToWorld(World world){
        for(int i=0; i < TileRows; i++){
            for(int b=0; b < TileCols; b++){
                 RMap[i][b] = new Tiles();
                 world.addObject(RMap[i][b], 16+b*TileWidth, 16+i*TileHeight); 
            }
        }    
        drawMap(CurrentMapX, CurrentMapY);
    }
    public void drawMap(int mX, int mY){
        CurrentMapX = mX;
        CurrentMapY = mY;
        for(int i=CurrentMapY; i < (TileRows+CurrentMapY); i++){
            for(int b=CurrentMapX; b < (TileCols+CurrentMapX); b++){
                RMap[i-CurrentMapY][b-CurrentMapX].image(TileImages[CurrentMap[i][b]],TileWalk[CurrentMap[i][b]]);
            }
        }
    }
    public int currentX(){
        return CurrentMapX;
    }
    public int currentY(){
        return CurrentMapY;
    }
    public int[][] currentMap(){
        return CurrentMap;
    }
    public Tiles tileAt(int mX, int mY){
        if(mX>0 && mX<(TileCols-1) && mY>0 && mY<(TileRows-1)){
            return RMap[mY][mX];
        }else{
            Tiles tmp = new Tiles();
            tmp.image(null,0);
            return tmp;
        }
    }
    public int tileH(){
        return TileHeight;
    }
    public int tileW(){
        return TileWidth;
    }
    public int tileR(){
        return TileRows;
    }
    public int tileC(){
        return TileCols;
    }
    public int rows(){
        return CurrentMap.length;
    }
    public int cols(){
        return CurrentMap[0].length;
    }
    /**
     * Act - do whatever the Map wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
