import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Monster here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Monster  extends Actor
{
    /**
     * Act - do whatever the Monster wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    private GreenfootImage battleImages[];
    private String monsterName;
    private int level, experiencePoints, healthPoints, attackStrength, defenseStrength;
    private boolean alive = true;
    public Monster(){
    }
    public void setupMonster(String name, int exp, int hp, int attk, int def, GreenfootImage battle[]){
        monsterName = name;
        healthPoints = hp;
        attackStrength = attk;
        defenseStrength = def;
        experiencePoints = exp;
        battleImages = battle;
        alive = true;
    }
    public void act() 
    {
        // Add your action code here.
        
    }
    protected GreenfootImage getBattleImage(){
        return battleImages[0];
    }
    public String getName(){
        return monsterName;
    }
    public boolean isAlive(){
        return alive;
    }
    public void attacked(int dmg){
        healthPoints -= dmg-defenseStrength;
        if(healthPoints <= 0){
            healthPoints = 0;
            alive = false;
        }
    }
    public int expGained(){
        return experiencePoints;
    }
    public int attack(){
        return attackStrength;
    }
    public int[] getStats(){
        return new int[]{level, healthPoints, attackStrength, defenseStrength, experiencePoints};
    }
}
