import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Attention here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Attention  extends UIControls
{
    /**
     * Act - do whatever the Attention wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private String displayMessage;
    private final int stringLen = 60;
    public Attention(String msg){
        displayMessage = msg;
    }
    public String[] splitUp(){
        String[] ret = new String[10];
        int lastPos = 0;
        if(displayMessage.length()<stringLen)
            return new String[]{displayMessage};
        for(int i=0; i<ret.length; i++){
                int tempPos = displayMessage.length()-lastPos-1;
                if(tempPos < 0)
                    break;
                if(tempPos<stringLen){
                    ret[i] = displayMessage.substring(lastPos, displayMessage.length()-1);
                    break;
                }else{
                    
                    ret[i] = displayMessage.substring(lastPos, lastPos+stringLen);
                    if(displayMessage.charAt(lastPos+stringLen)!= ' ' && displayMessage.charAt(lastPos+stringLen-1)!= ' '){
                        ret[i] += "-";
                    }
                }
                lastPos += stringLen;
        }
        return ret;
    }
    public void addedToWorld(World world){
        String tmp[] = splitUp();
        int line = 1;
        int height = (tmp.length+2)*10 + 40;
        int width = 450;
        setLocation(225+getX(), 75+getY());
        getImage().clear();
        getImage().scale(width,height);
        getImage().setColor(new Color(0,0,255));
        getImage().fillRect(0, 0, width, height);
        getImage().setColor(new Color(0, 0, 0));
        getImage().fillRect(5,5, width-10, height-10);
        getImage().setColor(new Color(255, 255, 255));
        for(int i=0; i < tmp.length; i++){
            if(tmp[i]==null)
                break;
            getImage().drawString(tmp[i], 20, 20*line);
            line++;
        }
        getImage().drawString("<Press spacebar to continue>",  250, height-10);
        
    }
    public void act() 
    {
        // Add your action code here.
        if(Greenfoot.isKeyDown("space")){
            getWorld().removeObject(this);
        }
    }    
}
